View Issue Details

IDProjectCategoryView StatusLast Update
0034714LazarusLCLpublic2018-12-20 23:50
ReporterPavol SAssigned ToMichl 
PrioritynormalSeverityminorReproducibilityalways
Status resolvedResolutionfixed 
PlatformWin32OS10OS Version
Product Version2.0RC2Product Build59373 
Target VersionFixed in Version 
Summary0034714: TGraphicControl.Cursor not working properly with TScrollBox
DescriptionCursor handling is not correct when scrolling with scrollbars (only TGraphicsControl based controls). See picture, only red part have correct cursor (after scrolling).
Steps To Reproduce1. place TShape on bottom of ScrollBox (only top part of TShape is visible) as on picture.
2. set Shape1.Cursor := crHandPoint;
TagsNo tags attached.
Fixed in Revision59865
LazTarget-
WidgetsetWin32/Win64
Attached Files

Relationships

related to 0032392 resolvedMichl Incorrect mouse position for TScrollingWinControl during DragNDrop 

Activities

Pavol S

2018-12-18 13:53

reporter  

bug-scrollbar.png (7,285 bytes)
bug-scrollbar.png (7,285 bytes)

wp

2018-12-18 14:21

developer   ~0112662

The cursor is only displayed for visible controls - this is by design because it would be extremely confusing to the user when the cursor suddenly changes above some places on the form for no obvious reason.

The TShape control in the screenshot does have Visible = true, but part of it has been moved out of the visible part of its owner. Therefore the same argument applies for the non-visible part.

Pavol S

2018-12-18 14:27

reporter   ~0112663

Last edited: 2018-12-18 14:31

View 2 revisions

wp: You must run example and scroll to see problem. Only red part will have crHandpoint and bottom of TShape will have crDefault (whole TShape will be visible on screen).

Please see new uploaded file to explain "red area".

Pavol S

2018-12-18 14:29

reporter  

bug-runtime.png (8,914 bytes)
bug-runtime.png (8,914 bytes)

wp

2018-12-18 15:32

developer   ~0112665

OK I see the issue now: Initially, a part of the TShape reached beyond the bounds of the TScrollbox. Then you scroll the TScrollbox such that the TShape is fully visible. But the cursor of the previously invisible region does not change to the cursor assigned to the TShape although it is visible now. The cursor is displayed correctly only for the initially visible part.

Michl

2018-12-19 14:06

developer   ~0112697

Fixed in trunk. Please test and close if ok.

Michl

2018-12-19 14:10

developer  

test.zip (2,763 bytes)

Zeljan Rikalo

2018-12-20 11:26

developer   ~0112748

@Michl, have you tested other widgetsets for this change ?

Michl

2018-12-20 23:02

developer   ~0112765

Yes, I checked Win32, Gtk2 and Qt. These are working fine now.

Michl

2018-12-20 23:50

developer   ~0112768

GTK3 has problems with the test app above, but they were there before r59865.

Issue History

Date Modified Username Field Change
2018-12-18 13:53 Pavol S New Issue
2018-12-18 13:53 Pavol S File Added: bug-scrollbar.png
2018-12-18 14:21 wp Note Added: 0112662
2018-12-18 14:27 Pavol S Note Added: 0112663
2018-12-18 14:29 Pavol S File Added: bug-runtime.png
2018-12-18 14:31 Pavol S Note Edited: 0112663 View Revisions
2018-12-18 15:32 wp Note Added: 0112665
2018-12-18 22:08 Michl Assigned To => Michl
2018-12-18 22:08 Michl Status new => assigned
2018-12-18 22:08 Michl Relationship added related to 0032392
2018-12-18 22:41 Michl File Added: test.zip
2018-12-19 11:30 Michl File Deleted: test.zip
2018-12-19 11:30 Michl File Added: test.zip
2018-12-19 14:06 Michl Fixed in Revision => 59865
2018-12-19 14:06 Michl LazTarget => -
2018-12-19 14:06 Michl Note Added: 0112697
2018-12-19 14:06 Michl Status assigned => resolved
2018-12-19 14:06 Michl Resolution open => fixed
2018-12-19 14:10 Michl File Deleted: test.zip
2018-12-19 14:10 Michl File Added: test.zip
2018-12-20 11:26 Zeljan Rikalo Note Added: 0112748
2018-12-20 23:02 Michl Note Added: 0112765
2018-12-20 23:50 Michl Note Added: 0112768